#define __lc_time_data_LEN		303
#define __lc_time_rows_LEN		100
#define __lc_time_item_offsets_LEN		50
#define __lc_time_item_idx_LEN		53
#define __lc_numeric_data_LEN		7
#define __lc_numeric_rows_LEN		6
#define __lc_numeric_item_offsets_LEN		3
#define __lc_numeric_item_idx_LEN		5
#define __lc_monetary_data_LEN		25
#define __lc_monetary_rows_LEN		44
#define __lc_monetary_item_offsets_LEN		22
#define __lc_monetary_item_idx_LEN		43
#define __lc_messages_data_LEN		29
#define __lc_messages_rows_LEN		8
#define __lc_messages_item_offsets_LEN		4
#define __lc_messages_item_idx_LEN		6
#define __lc_ctype_data_LEN		21
#define __lc_ctype_rows_LEN		10
#define __lc_ctype_item_offsets_LEN		10
#define __lc_ctype_item_idx_LEN		10
#define __CTYPE_HAS_UTF_8_LOCALES			1
#define CATEGORIES			6
#define WIDTH_LOCALES			9
#define NUM_LOCALES			2
#define NUM_LOCALE_NAMES		2
#define LOCALE_AT_MODIFIERS_LENGTH		18
#define lc_names_LEN		69
#define __lc_collate_data_LEN  7370
#define __CTYPE_HAS_8_BIT_LOCALES		1

#define Cctype_IDX_SHIFT	3
#define Cctype_IDX_LEN		16
#define Cctype_ROW_LEN		4
#define Cctype_PACKED		1

#define Cuplow_IDX_SHIFT	3
#define Cuplow_IDX_LEN		16
#define Cuplow_ROW_LEN		8

#define Cc2wc_IDX_LEN		16
#define Cc2wc_IDX_SHIFT		3
#define Cc2wc_ROW_LEN		8

typedef struct {
	unsigned char idx8ctype[16];
	unsigned char idx8uplow[16];
	unsigned char idx8c2wc[16];
	unsigned char idx8wc2c[38];
} codeset_8_bit_t;

#ifdef WANT_DATA

static const codeset_8_bit_t codeset_8_bit[1] = {
	{ /* ISO-8859-1 */
		/* idx8ctype data */
		{    0,    0,    0,    0,  0x1,  0x2,  0x3,  0x2,
		   0x4,  0x4,  0x5,  0x6,  0x7,  0x7,  0x8,  0x7, },
		/* idx8uplow data */
		{    0,    0,    0,    0,    0,    0,    0,    0,
		   0x1,  0x1,  0x2,  0x2,  0x1,  0x1,  0x2,  0x2, },
		/* idx8c2wc data */
		{    0,  0x1,  0x2,  0x3,  0x4,  0x5,  0x6,  0x7,
		   0x8,  0x9,  0xa,  0xb,  0xc,  0xd,  0xe,  0xf, },
		/* idx8wc2c data */
		{    0,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,
		   0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,
		   0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,
		   0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,  0x1,
		   0x1,  0x1,  0x1,  0x1,  0x1,  0x1, }
	},
};

#endif /* WANT_DATA */

#define Cwc2c_DOMAIN_MAX	0x25ff
#define Cwc2c_TI_SHIFT		4
#define Cwc2c_TT_SHIFT		4
#define Cwc2c_II_LEN		38
#define Cwc2c_TI_LEN		32
#define Cwc2c_TT_LEN		144


#define Cwc2c_TBL_LEN		176
#ifdef WANT_DATA

static const unsigned char Cwc2c_data[176] = {
	/* ti_table */
	    0,    0,    0,    0,    0,    0,    0,    0,
	  0x1,  0x2,  0x3,  0x4,  0x5,  0x6,  0x7,  0x8,
	    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,
	/* tt_table */
	    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,
	 0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
	 0x88, 0x89, 0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f,
	 0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97,
	 0x98, 0x99, 0x9a, 0x9b, 0x9c, 0x9d, 0x9e, 0x9f,
	 0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7,
	 0xa8, 0xa9, 0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
	 0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7,
	 0xb8, 0xb9, 0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf,
	 0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7,
	 0xc8, 0xc9, 0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
	 0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7,
	 0xd8, 0xd9, 0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
	 0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7,
	 0xe8, 0xe9, 0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
	 0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7,
	 0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff,
};

#endif /* WANT_DATA */

#define Cuplow_TBL_LEN		24

#ifdef WANT_DATA


static const unsigned char Cuplow_data[24] = {
	    0,    0,    0,    0,    0,    0,    0,    0,
	 0xe0, 0xe0, 0xe0, 0xe0, 0xe0, 0xe0, 0xe0, 0xe0,
	 0xe0, 0xe0, 0xe0, 0xe0, 0xe0, 0xe0, 0xe0,    0,
};

#endif /* WANT_DATA */

#define Cctype_TBL_LEN		36

#ifdef WANT_DATA


static const unsigned char Cctype_data[36] = {
	 0xee, 0xee, 0xee, 0xee,
	 0x66, 0x66, 0x66, 0x66,
	 0x66, 0x61, 0x66, 0x66,
	 0x66, 0x66, 0x26, 0x66,
	 0x44, 0x44, 0x44, 0x44,
	 0x44, 0x44, 0x44, 0x64,
	 0x44, 0x44, 0x44, 0x24,
	 0x22, 0x22, 0x22, 0x22,
	 0x22, 0x22, 0x22, 0x62,
};

#endif /* WANT_DATA */

#define Cc2wc_TBL_LEN		128

#ifdef WANT_DATA


static const unsigned short Cc2wc_data[128] = {
	   0x80,   0x81,   0x82,   0x83,   0x84,   0x85,   0x86,   0x87,
	   0x88,   0x89,   0x8a,   0x8b,   0x8c,   0x8d,   0x8e,   0x8f,
	   0x90,   0x91,   0x92,   0x93,   0x94,   0x95,   0x96,   0x97,
	   0x98,   0x99,   0x9a,   0x9b,   0x9c,   0x9d,   0x9e,   0x9f,
	   0xa0,   0xa1,   0xa2,   0xa3,   0xa4,   0xa5,   0xa6,   0xa7,
	   0xa8,   0xa9,   0xaa,   0xab,   0xac,   0xad,   0xae,   0xaf,
	   0xb0,   0xb1,   0xb2,   0xb3,   0xb4,   0xb5,   0xb6,   0xb7,
	   0xb8,   0xb9,   0xba,   0xbb,   0xbc,   0xbd,   0xbe,   0xbf,
	   0xc0,   0xc1,   0xc2,   0xc3,   0xc4,   0xc5,   0xc6,   0xc7,
	   0xc8,   0xc9,   0xca,   0xcb,   0xcc,   0xcd,   0xce,   0xcf,
	   0xd0,   0xd1,   0xd2,   0xd3,   0xd4,   0xd5,   0xd6,   0xd7,
	   0xd8,   0xd9,   0xda,   0xdb,   0xdc,   0xdd,   0xde,   0xdf,
	   0xe0,   0xe1,   0xe2,   0xe3,   0xe4,   0xe5,   0xe6,   0xe7,
	   0xe8,   0xe9,   0xea,   0xeb,   0xec,   0xed,   0xee,   0xef,
	   0xf0,   0xf1,   0xf2,   0xf3,   0xf4,   0xf5,   0xf6,   0xf7,
	   0xf8,   0xf9,   0xfa,   0xfb,   0xfc,   0xfd,   0xfe,   0xff,
};

#endif /* WANT_DATA */


#define NUM_CODESETS		1
#define CODESET_LIST \
	"\x02" \
	"\0" \
	"ISO-8859-1\0"

#define __CTYPE_HAS_CODESET_ISO_8859_1
#define __CTYPE_HAS_CODESET_UTF_8
#define WC_TABLE_DOMAIN_MAX   0x2ffff

#define WCctype_II_LEN        768
#define WCctype_TI_LEN       1888
#define WCctype_UT_LEN        948
#define WCctype_II_SHIFT        5
#define WCctype_TI_SHIFT        3

#ifdef WANT_WCctype_data

static const unsigned char WCctype_data[3604] = {
 0x3a, 0x21, 0x1f, 0x32, 0x23, 0x1e, 0x02, 0x2c, 0000, 0x27, 0x04, 0x25,
 0x26, 0x05, 0x07, 0x29, 0x0f, 0x12, 0x09, 0x0c, 0x06, 0x19, 0x1a, 0x0b,
 0x2b, 0000, 0000, 0000, 0000, 0000, 0x20, 0x1d, 0x39, 0x2a, 0x37, 0x34,
 0x30, 0x37, 0x2e, 0x24, 0x37, 0x37, 0x37, 0000, 0000, 0000, 0x01, 0x35,
 0x38, 0x03, 0x2f, 0x33, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x17, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x16, 0x19, 0x19, 0x19, 0x19, 0x13, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x14,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x37, 0x37, 0x37, 0x37,
 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x37,
 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x37, 0x19, 0x10, 0x08,
 0x19, 0x1b, 0x2d, 0x28, 0000, 0000, 0000, 0x0e, 0x22, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x36, 0x31, 0000, 0000,
 0x11, 0x0a, 0x15, 0x1c, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x19,
 0x19, 0x19, 0x19, 0x19, 0x19, 0x19, 0x18, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0x19, 0x19, 0x0d, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0xe4, 0xe4, 0xe4, 0xcd, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xd0, 0000, 0000, 0x07, 0000, 0x1a, 0x35, 0x55, 0x55, 0x3e,
 0x55, 0x6a, 0xde, 0000, 0x55, 0x6f, 0x76, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x5a, 0xe4, 0xda, 0xde, 0x55, 0x5c,
 0x08, 0x55, 0x55, 0x55, 0x55, 0x49, 0x35, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x53, 0xe4, 0xe4, 0x55, 0x55, 0x55, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0x55, 0x55, 0x12, 0x3f, 0x23, 0x55,
 0x55, 0x28, 0x25, 0x3b, 0xc4, 0x2d, 0000, 0x32, 0x03, 0x55, 0xc7, 0000,
 0xb6, 0x50, 0x47, 0x55, 0x55, 0x28, 0x26, 0x3d, 0xe3, 0xcc, 0x1f, 0000,
 0x20, 0x55, 0000, 0000, 0x1d, 0x4c, 0x28, 0x55, 0x55, 0x28, 0x55, 0x3a,
 0xd2, 0x2e, 0x04, 0000, 0x39, 0x55, 0000, 0000, 0x1d, 0x55, 0x53, 0x17,
 0x55, 0x55, 0x47, 0x4f, 0x53, 0x11, 0xd5, 0xe4, 0000, 0000, 0x1c, 0000,
 0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x35, 0x55, 0x55, 0x55,
 0x55, 0x58, 0x55, 0x41, 0x56, 0x58, 0x55, 0x6b, 0000, 0000, 0000, 0000,
 0x2f, 0x22, 0x0b, 0x35, 0x34, 0x16, 0xbc, 0xcb, 0x4a, 0xde, 0x55, 0x3c,
 0000, 0000, 0000, 0000, 0x53, 0000, 0x14, 0x09, 0x55, 0xbb, 0x53, 0x4a,
 0x44, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x37, 0000, 0000, 0000, 0x14, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x53, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x53, 0x27, 0x53, 0x27,
 0x55, 0x55, 0x55, 0x55, 0x53, 0x27, 0x55, 0x55, 0x55, 0x53, 0x27, 0x53,
 0x27, 0x53, 0x53, 0x55, 0x55, 0x53, 0x55, 0x55, 0x54, 0x42, 0x4c, 0x4c,
 0x55, 0x55, 0x55, 0x46, 0x4a, 0x17, 0x28, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x4c, 0x6d, 0000, 0x55, 0x55, 0x6e, 0000,
 0x55, 0x55, 0x6b, 0000, 0x55, 0x4c, 0x2a, 0000, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x60, 0xe4, 0xe4, 0xe4, 0xe2, 0xd3, 0x55, 0x37, 0000, 0000,
 0x55, 0x53, 0x27, 0x53, 0x55, 0x55, 0x55, 0x55, 0x53, 0x55, 0x55, 0x3e,
 0xb9, 0x76, 0x70, 0xd4, 0000, 0000, 0000, 0000, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x49, 0000, 0x55, 0x55, 0x55, 0x52,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0x55, 0x55, 0x55, 0x53, 0xd0, 0000, 0x55, 0x55,
 0x55, 0x3e, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0x55, 0x55, 0x55, 0x55, 0x47, 0x31, 0xc5, 0xc0, 0x55, 0x70, 0x59, 0xc0,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x55, 0x55, 0x55, 0x55,
 0x52, 0000, 0x55, 0x55, 0x55, 0x55, 0x55, 0x29, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x52, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x3e, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x4c, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x4c,
 0x10, 0x33, 0x55, 0x45, 0x26, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x38,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x3e, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x37, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x49, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe0, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x48, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x48, 0x55, 0x55, 0x55,
 0xbb, 0x55, 0x55, 0x68, 0x55, 0x55, 0x55, 0x68, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x52, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x52, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x53, 0000, 0000, 0000, 0000, 0000, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x5e, 0x53, 0000, 0x78, 0x55, 0x55, 0x67,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x69, 0x1f, 0000,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x59, 0000, 0000, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x17, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0000, 0000, 0000, 0000, 0000, 0x55, 0x4e, 0x55, 0x55, 0x5d, 0x55,
 0x55, 0x55, 0x5d, 0x55, 0x55, 0x58, 0x55, 0x55, 0x55, 0x58, 0x55, 0x55,
 0x55, 0xbb, 0x55, 0x55, 0x55, 0xbb, 0x55, 0x55, 0x68, 0x39, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x86, 0xaa, 0x83, 0xa7, 0x86, 0xaa, 0x86, 0xaa,
 0x83, 0xa7, 0x7b, 0x96, 0x86, 0xaa, 0x86, 0x83, 0x86, 0xaa, 0x86, 0xaa,
 0x86, 0xaa, 0x82, 0xae, 0xc9, 0xaf, 0x7d, 0xac, 0x7f, 0xaf, 0x19, 0xad,
 0x92, 0x92, 0000, 0000, 0000, 0000, 0x97, 0xaa, 0xaa, 0xaa, 0xa8, 0x36,
 0x79, 0x86, 0x86, 0x86, 0x85, 0xb4, 0xb9, 0xe4, 0xcd, 0xe4, 0xe4, 0xcd,
 0xd4, 0000, 0x55, 0x55, 0x55, 0x3e, 0x67, 0000, 0x92, 0x92, 0x92, 0x92,
 0x2b, 0x92, 0x8f, 0000, 0000, 0000, 0x65, 0x7a, 0x71, 0x7e, 0x62, 0x55,
 0x71, 0x72, 0x61, 0x55, 0x55, 0x52, 0x55, 0xbd, 0x70, 0xe4, 0x70, 0xe4,
 0x5f, 0xdf, 0000, 0000, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92,
 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x91, 0x64,
 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x8c,
 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x92, 0x9a, 0x9f, 0x73, 0x92, 0x92,
 0x92, 0x92, 0x92, 0xa5, 0x99, 0xa0, 0xa4, 0x8e, 0x93, 0x9c, 0xa1, 0x8d,
 0x5b, 0x8b, 0x9f, 0x9d, 0x92, 0x92, 0x98, 0x92, 0xaa, 0xaa, 0xaa, 0xaa,
 0xa7, 0x86, 0x86, 0x86, 0x86, 0x83, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0x86, 0x86,
 0x86, 0x86, 0x86, 0x86, 0x92, 0x92, 0x92, 0x92, 0x94, 0xca, 0x92, 0x92,
 0x92, 0x92, 0x92, 0x92, 0x9a, 0x9e, 0x92, 0x92, 0x92, 0x92, 0x90, 0x8c,
 0xb5, 0xc1, 0xe4, 0xe4, 0xe4, 0xb9, 0xe4, 0xe4, 0xe4, 0xdc, 0xc3, 0xe0,
 0xb9, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xd4, 0xe4, 0xe4, 0xe4, 0xb9, 0xe0,
 0000, 0000, 0xe4, 0xe4, 0xe4, 0xd0, 0xe4, 0xe4, 0xb6, 0x4b, 0x23, 0x55,
 0x55, 0x28, 0x24, 0x3d, 0xd1, 0x2d, 0x05, 0x0a, 0x39, 0x55, 0x2c, 0000,
 0x18, 0x40, 0x27, 0x30, 0x13, 0x40, 0x54, 0x3a, 0xc5, 0x2e, 0x04, 0000,
 0x02, 0x55, 0xc2, 0000, 0xb6, 0x4c, 0x28, 0x55, 0x55, 0x28, 0x51, 0x3a,
 0xd7, 0x2e, 0x0c, 0000, 0x39, 0x55, 0000, 0000, 0x1d, 0x4c, 0x28, 0x55,
 0x55, 0x28, 0x51, 0x3a, 0xd7, 0x2e, 0x0c, 0x01, 0x39, 0x55, 0000, 0000,
 0xb6, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x3d, 0xe4, 0xde, 0xbe, 0x55,
 0x6f, 0x55, 0x2c, 0000, 0xb6, 0x4b, 0x23, 0x55, 0x55, 0x28, 0x21, 0x3b,
 0xd6, 0x2d, 0x04, 0x0a, 0x6c, 0x55, 0x70, 0xc2, 0xb9, 0xe4, 0x55, 0x70,
 0xb1, 0xaa, 0xaa, 0xb0, 0x95, 0x86, 0x86, 0x88, 0xe1, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x53, 0x17, 0x17, 0x17, 0x15,
 0xe0, 0xe0, 0000, 0xb8, 0xbf, 0xe4, 0xe4, 0xe4, 0x55, 0x70, 0xe4, 0xe4,
 0x55, 0x35, 0x55, 0x55, 0x55, 0x3e, 0xb9, 0xe4, 0xe4, 0x48, 0xe4, 0xb9,
 0xe4, 0xe4, 0xe4, 0xd7, 0xe4, 0xd6, 0000, 0000, 0000, 0000, 0000, 0000,
 0xce, 0xc8, 0x5a, 0x77, 0xdd, 0x66, 0x63, 0x43, 0xd9, 0x6b, 0x1b, 0xe4,
 0xaa, 0xaa, 0x86, 0x86, 0x48, 0000, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe0, 0x55, 0x37,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0000,
 0x55, 0x55, 0x55, 0x55, 0x55, 0xba, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0xe4, 0xe3, 0xbb, 0x55, 0x55, 0x49, 0xe4, 0xe4,
 0xe4, 0xc2, 0000, 0000, 0000, 0000, 0000, 0000, 0x55, 0x55, 0x55, 0x55,
 0x59, 0xe4, 0x74, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0xe4, 0xe4, 0000, 0000, 0xd0, 0000, 0xe4, 0xe4, 0xe5, 0xb9, 0xc6, 0xe4,
 0xe0, 0xd0, 0x4c, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x4d, 0xe4, 0xe4, 0xd2, 0xb9,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xde,
 0xe4, 0xc0, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0xe4, 0xe4, 0xe4, 0xd4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xd0, 0000, 0xb9, 0xe4, 0xe4, 0xe4, 0xe4, 0xd1, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xd0, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe0,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe0, 0000, 0000, 0000, 0xe4, 0xc2, 0000, 0000,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xd8, 0x55, 0x55, 0x57, 0xaa,
 0xaa, 0xaa, 0x86, 0x86, 0x86, 0x8a, 0xe4, 0xe0, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe0, 0x1e, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xde,
 0000, 0000, 0000, 0000, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xdb, 0xe4, 0000, 0000, 0xe4, 0xe4, 0x0d, 0x0f, 0x0e, 0xa2, 0x9b, 0xaa,
 0xa3, 0xa6, 0x7c, 0x86, 0x86, 0x84, 0x80, 0x92, 0x92, 0x92, 0x81, 0000,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe0, 0x1b, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xde, 0xe4, 0xe4, 0xe4, 0xe0, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe0, 0000, 0000,
 0000, 0000, 0000, 0000, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xde, 0000, 0000, 0000, 0xe4, 0xd0,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xde, 0000, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4, 0xe4,
 0xe4, 0xe4, 0xe4, 0xe4, 0xe6, 0xe4, 0xe4, 0xe4, 0x76, 0x70, 0x77, 0x5f,
 0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x53, 0xb7,
 0x76, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x68,
 0xe9, 0xe8, 0xe4, 0xe4, 0xe4, 0xea, 0xe4, 0xe4, 0xe4, 0xe4, 0xc4, 0x06,
 0xd0, 0x1e, 0x75, 0xe2, 0xe4, 0xe0, 0000, 0000, 0xe4, 0xe4, 0xc0, 0000,
 0000, 0000, 0xe4, 0xe4, 0xe4, 0xc2, 0000, 0000, 0xec, 0xeb, 0xec, 0xec,
 0xe7, 0xe4, 0xb2, 0xb3, 0xb1, 0xaa, 0xaa, 0xb0, 0x95, 0x86, 0x86, 0x89,
 0xec, 0xec, 0xec, 0xec, 0xe4, 0xcf, 0xdb, 0xcf, 0xaa, 0xaa, 0xab, 0xa9,
 0x86, 0x86, 0x87, 0x86,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x01, 0000, 0000, 0000, 0x10,
 0000, 0000, 0000, 0x11, 0000, 0000, 0000, 0x60, 0000, 0000, 0000, 0x66,
 0000, 0000, 0000, 0x90, 0000, 0000, 0x06, 0000, 0000, 0000, 0x10, 0x11,
 0000, 0000, 0x10, 0x16, 0000, 0000, 0x11, 0x10, 0000, 0000, 0x11, 0x11,
 0000, 0000, 0x60, 0x06, 0000, 0000, 0x66, 0000, 0000, 0000, 0x66, 0x64,
 0000, 0x01, 0000, 0x06, 0000, 0x01, 0x10, 0x01, 0000, 0x06, 0000, 0x60,
 0000, 0x06, 0x10, 0x11, 0000, 0x10, 0x01, 0000, 0000, 0x10, 0x11, 0x11,
 0000, 0x11, 0x01, 0000, 0000, 0x11, 0x10, 0x11, 0000, 0x11, 0x11, 0x11,
 0000, 0x16, 0x10, 0x11, 0000, 0x21, 0x01, 0x11, 0000, 0x60, 0000, 0x60,
 0000, 0x60, 0x66, 0x66, 0000, 0x66, 0x06, 0000, 0000, 0x66, 0x10, 0x11,
 0000, 0x66, 0x66, 0x66, 0x01, 0000, 0000, 0000, 0x01, 0000, 0000, 0x11,
 0x01, 0x01, 0000, 0x11, 0x01, 0x01, 0x10, 0000, 0x01, 0x10, 0x11, 0x11,
 0x01, 0x11, 0000, 0x11, 0x01, 0x11, 0x10, 0x01, 0x01, 0x11, 0x10, 0x11,
 0x01, 0x11, 0x11, 0000, 0x01, 0x11, 0x11, 0x11, 0x01, 0x60, 0000, 0000,
 0x01, 0x66, 0000, 0000, 0x04, 0x24, 0x24, 0x24, 0x06, 0000, 0000, 0000,
 0x06, 0x60, 0x66, 0000, 0x06, 0x66, 0x66, 0000, 0x10, 0x01, 0x01, 0x10,
 0x10, 0x01, 0x01, 0x11, 0x10, 0x01, 0x66, 0x66, 0x10, 0x11, 0x01, 0x01,
 0x10, 0x11, 0x01, 0x11, 0x10, 0x11, 0x10, 0x10, 0x10, 0x11, 0x11, 0x11,
 0x10, 0x66, 0x66, 0x66, 0x11, 0000, 0000, 0000, 0x11, 0000, 0000, 0x10,
 0x11, 0000, 0000, 0x11, 0x11, 0000, 0000, 0x66, 0x11, 0000, 0x06, 0x66,
 0x11, 0000, 0x11, 0000, 0x11, 0000, 0x16, 0x66, 0x11, 0x01, 0000, 0000,
 0x11, 0x01, 0000, 0x10, 0x11, 0x01, 0000, 0x11, 0x11, 0x01, 0000, 0x60,
 0x11, 0x01, 0x10, 0x11, 0x11, 0x06, 0x10, 0x11, 0x11, 0x10, 0x01, 0x11,
 0x11, 0x10, 0x10, 0x11, 0x11, 0x10, 0x11, 0x01, 0x11, 0x10, 0x11, 0x11,
 0x11, 0x11, 0000, 0000, 0x11, 0x11, 0x01, 0000, 0x11, 0x11, 0x01, 0x01,
 0x11, 0x11, 0x01, 0x10, 0x11, 0x11, 0x01, 0x11, 0x11, 0x11, 0x01, 0x60,
 0x11, 0x11, 0x06, 0000, 0x11, 0x11, 0x10, 0000, 0x11, 0x11, 0x10, 0x10,
 0x11, 0x11, 0x10, 0x11, 0x11, 0x11, 0x11, 0000, 0x11, 0x11, 0x11, 0x01,
 0x11, 0x11, 0x11, 0x10, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x16,
 0x11, 0x11, 0x11, 0x44, 0x11, 0x11, 0x11, 0x61, 0x11, 0x11, 0x11, 0x66,
 0x11, 0x11, 0x16, 0x66, 0x11, 0x11, 0x34, 0x42, 0x11, 0x11, 0x61, 0x06,
 0x11, 0x11, 0x61, 0x11, 0x11, 0x11, 0x61, 0x16, 0x11, 0x11, 0x61, 0x66,
 0x11, 0x11, 0x66, 0x66, 0x11, 0x12, 0x11, 0x11, 0x11, 0x12, 0x21, 0x11,
 0x11, 0x16, 0x11, 0x11, 0x11, 0x21, 0000, 0000, 0x11, 0x21, 0x12, 0x22,
 0x11, 0x44, 0x11, 0x16, 0x11, 0x61, 0x06, 0000, 0x11, 0x61, 0x11, 0x11,
 0x11, 0x61, 0x66, 0x11, 0x11, 0x61, 0x66, 0x66, 0x11, 0x66, 0000, 0000,
 0x11, 0x66, 0000, 0x11, 0x11, 0x66, 0x06, 0000, 0x11, 0x66, 0x66, 0x06,
 0x11, 0x66, 0x66, 0x11, 0x11, 0x66, 0x66, 0x66, 0x12, 0x21, 0x11, 0x11,
 0x12, 0x22, 0x11, 0x11, 0x12, 0x24, 0x24, 0x24, 0x16, 0000, 0000, 0000,
 0x16, 0000, 0x66, 0x66, 0x16, 0x11, 0x11, 0x11, 0x16, 0x11, 0x11, 0x66,
 0x19, 0x11, 0x11, 0x11, 0x20, 0x22, 0x22, 0x22, 0x21, 0x21, 0x11, 0x11,
 0x21, 0x21, 0x21, 0x21, 0x21, 0x22, 0x22, 0x22, 0x22, 0x11, 0000, 0x11,
 0x22, 0x11, 0x11, 0x21, 0x22, 0x11, 0x21, 0x11, 0x22, 0x11, 0x21, 0x12,
 0x22, 0x12, 0x24, 0x06, 0x22, 0x21, 0x01, 0x11, 0x22, 0x22, 0x22, 0000,
 0x22, 0x22, 0x22, 0x02, 0x22, 0x22, 0x22, 0x12, 0x22, 0x22, 0x22, 0x22,
 0x22, 0x22, 0x22, 0x62, 0x22, 0x62, 0x66, 0x66, 0x22, 0x62, 0x66, 0xe6,
 0x22, 0x66, 0x66, 0x66, 0x23, 0x34, 0x42, 0x42, 0x24, 0000, 0000, 0000,
 0x24, 0x11, 0x24, 0x21, 0x24, 0x11, 0x44, 0x42, 0x24, 0x24, 0000, 0000,
 0x24, 0x24, 0x24, 0000, 0x24, 0x24, 0x24, 0x11, 0x24, 0x24, 0x24, 0x24,
 0x24, 0x24, 0x24, 0x44, 0x24, 0x66, 0x66, 0x06, 0x26, 0x22, 0x22, 0x22,
 0x40, 0x40, 0x40, 0x40, 0x40, 0x44, 0x44, 0x44, 0x41, 0x23, 0x24, 0x44,
 0x41, 0x24, 0x24, 0x44, 0x41, 0x42, 0x42, 0x42, 0x41, 0x44, 0x44, 0x44,
 0x42, 0x11, 0x24, 0x44, 0x42, 0x42, 0x22, 0x24, 0x42, 0x42, 0x42, 0x02,
 0x42, 0x42, 0x42, 0x42, 0x42, 0x44, 0x12, 0x44, 0x42, 0x44, 0x42, 0x42,
 0x44, 0x04, 0x04, 0x44, 0x44, 0x40, 0x44, 0x44, 0x44, 0x42, 0x24, 0x44,
 0x44, 0x42, 0x42, 0x22, 0x44, 0x44, 0x22, 0x22, 0x44, 0x44, 0x44, 0000,
 0x44, 0x44, 0x44, 0x04, 0x44, 0x44, 0x44, 0x24, 0x44, 0x44, 0x44, 0x44,
 0x44, 0x44, 0x44, 0x64, 0x44, 0x44, 0x60, 0x66, 0x44, 0x44, 0x64, 0x06,
 0x44, 0x44, 0x64, 0x62, 0x44, 0x44, 0x64, 0x66, 0x44, 0x64, 0x66, 0x66,
 0x46, 0x44, 0x44, 0x44, 0x55, 0x55, 0x55, 0x55, 0x55, 0x66, 0x66, 0x66,
 0x60, 0x06, 0000, 0000, 0x60, 0x66, 0x06, 0x66, 0x60, 0x66, 0x10, 0x11,
 0x60, 0x66, 0x16, 0x11, 0x60, 0x66, 0x66, 0000, 0x60, 0x66, 0x66, 0x66,
 0x61, 0000, 0000, 0000, 0x61, 0x11, 0x11, 0x11, 0x61, 0x11, 0x66, 0x66,
 0x61, 0x16, 0x11, 0x11, 0x61, 0x66, 0x06, 0000, 0x61, 0x66, 0x66, 0x66,
 0x66, 0000, 0000, 0000, 0x66, 0000, 0x66, 0x66, 0x66, 0x06, 0000, 0000,
 0x66, 0x06, 0000, 0x06, 0x66, 0x06, 0000, 0x60, 0x66, 0x06, 0000, 0x66,
 0x66, 0x06, 0x66, 0x66, 0x66, 0x11, 0x01, 0000, 0x66, 0x11, 0x11, 0x11,
 0x66, 0x21, 0x01, 0x11, 0x66, 0x24, 0x24, 0x24, 0x66, 0x60, 0x16, 0000,
 0x66, 0x60, 0x66, 0000, 0x66, 0x60, 0x66, 0x66, 0x66, 0x61, 0x66, 0x16,
 0x66, 0x61, 0x66, 0x66, 0x66, 0x66, 0000, 0000, 0x66, 0x66, 0000, 0x60,
 0x66, 0x66, 0000, 0x66, 0x66, 0x66, 0x01, 0000, 0x66, 0x66, 0x06, 0000,
 0x66, 0x66, 0x06, 0x06, 0x66, 0x66, 0x06, 0x60, 0x66, 0x66, 0x06, 0x66,
 0x66, 0x66, 0x11, 0x11, 0x66, 0x66, 0x16, 0x11, 0x66, 0x66, 0x16, 0x61,
 0x66, 0x66, 0x26, 0x66, 0x66, 0x66, 0x60, 0x60, 0x66, 0x66, 0x61, 0x64,
 0x66, 0x66, 0x66, 0000, 0x66, 0x66, 0x66, 0x01, 0x66, 0x66, 0x66, 0x06,
 0x66, 0x66, 0x66, 0x11, 0x66, 0x66, 0x66, 0x16, 0x66, 0x66, 0x66, 0x60,
 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x76, 0x07, 0x69, 0x66, 0x16, 0x11,
 0x69, 0x66, 0x66, 0x66, 0x99, 0x99, 0x66, 0x66, 0x99, 0x99, 0x99, 0x69,
 0xcc, 0x66, 0x66, 0x66, 0xde, 0xcc, 0xcc, 0xee, 0xee, 0xee, 0xee, 0xee,
};

#endif /* WANT_WCctype_data */

#define WCuplow_II_LEN        384
#define WCuplow_TI_LEN        576
#define WCuplow_UT_LEN        720
#define WCuplow_II_SHIFT        6
#define WCuplow_TI_SHIFT        3

#ifdef WANT_WCuplow_data

static const unsigned char WCuplow_data[1680] = {
 0x04, 0x06, 0x07, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0x05, 0x01, 0000, 0x03, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x02, 0000, 0000, 0x08, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0x02, 0x0d, 0000, 0000, 0000, 0000, 0000, 0000,
 0x51, 0x51, 0x52, 0x52, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x0e, 0x1b, 0x1b, 0x19,
 0x0f, 0x1f, 0x1f, 0x1d, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x03, 0x53,
 0x53, 0x53, 0x55, 0x55, 0x55, 0x54, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0x0e, 0x1b, 0x1b, 0x19, 0x0f, 0x1f, 0x1f, 0x1d, 0000, 0000, 0000, 0000,
 0000, 0000, 0x04, 0000, 0x1b, 0x1b, 0x1a, 0x1a, 0x1f, 0x1f, 0x1e, 0x20,
 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x31, 0x10, 0x2c, 0x2a, 0x28, 0x28,
 0x28, 0x28, 0x28, 0x32, 0x11, 0x2e, 0x33, 0x25, 0x29, 0x2f, 0x30, 0x24,
 0x06, 0x34, 0x2c, 0x2d, 0x28, 0x28, 0x12, 0x28, 0x28, 0x28, 0x28, 0x28,
 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28,
 0x28, 0x28, 0x27, 0x08, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28, 0x28,
 0x28, 0x28, 0x28, 0x23, 0x47, 0x49, 0x46, 0x48, 0x47, 0x49, 0x47, 0x49,
 0x46, 0x48, 0x16, 0x17, 0x47, 0x49, 0x4d, 0x4e, 0x47, 0x49, 0x47, 0x49,
 0x47, 0x49, 0x45, 0x4a, 0x09, 0x4f, 0x43, 0x4b, 0x44, 0x4c, 0x09, 0x50,
 0x28, 0x28, 0x28, 0x28, 0x35, 0x28, 0x26, 0000, 0000, 0000, 0x07, 0x13,
 0x36, 0x37, 0x0b, 0000, 0x38, 0x39, 0x0c, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0x05, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0x01, 0x3a, 0x0e, 0x1b, 0x18, 0x1c, 0x0f, 0x1f, 0x22, 0x21, 0x3b, 0x28,
 0x28, 0x28, 0x3c, 0000, 0x3e, 0x3e, 0x1b, 0x1b, 0x1b, 0x1b, 0x1f, 0x1f,
 0x1f, 0x1f, 0x3d, 0x3d, 0x28, 0x28, 0x28, 0x28, 0x23, 0x0a, 0x28, 0x28,
 0x28, 0x28, 0x28, 0x28, 0x10, 0x2b, 0x28, 0x28, 0x28, 0x28, 0x27, 0x23,
 0x28, 0x28, 0000, 0000, 0000, 0000, 0x14, 0x40, 0x40, 0x40, 0x3f, 0000,
 0x15, 0x42, 0x42, 0x42, 0x41, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x57, 0x57, 0x57, 0x57,
 0x56, 0x59, 0x59, 0x59, 0x59, 0x58, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0000,
 0000, 0000, 0x31, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x59, 0000,
 0000, 0000, 0000, 0000, 0000, 0000, 0x5e, 0x5e, 0000, 0000, 0000, 0000,
 0000, 0x03, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x30, 0000, 0000,
 0000, 0000, 0000, 0000, 0x1c, 0x1d, 0x1e, 0x1c, 0000, 0000, 0000, 0x23,
 0x24, 0000, 0x25, 0x25, 0000, 0000, 0000, 0x45, 0000, 0000, 0000, 0000,
 0000, 0000, 0000, 0x4e, 0000, 0000, 0000, 0000, 0000, 0000, 0x05, 0x06,
 0x05, 0x06, 0x05, 0x06, 0000, 0000, 0x2b, 0000, 0000, 0x2c, 0000, 0000,
 0000, 0000, 0x2f, 0000, 0000, 0000, 0000, 0000, 0000, 0000, 0x5a, 0x5b,
 0000, 0000, 0000, 0000, 0000, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
 0000, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0000, 0x05, 0x06, 0x05,
 0x06, 0x05, 0x06, 0x05, 0000, 0x0b, 0x05, 0x06, 0x05, 0x06, 0x0c, 0x05,
 0000, 0x1c, 0x1d, 0x1e, 0x05, 0x06, 0x20, 0x21, 0000, 0x26, 0000, 0x27,
 0000, 0000, 0000, 0000, 0000, 0x43, 0x43, 0x43, 0x43, 0x43, 0x43, 0x43,
 0000, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0000, 0x46, 0000, 0x46,
 0000, 0x46, 0000, 0x46, 0000, 0x47, 0000, 0x47, 0000, 0x47, 0000, 0x47,
 0x01, 0x01, 0000, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0000,
 0000, 0000, 0000, 0000, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0000,
 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01,
 0x35, 0x36, 0x36, 0x36, 0x02, 0x02, 0x02, 0000, 0000, 0000, 0000, 0000,
 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0000, 0x02, 0x02, 0x02, 0x02,
 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x04,
 0x02, 0x02, 0x02, 0x02, 0x38, 0x39, 0x39, 0000, 0x02, 0x02, 0x37, 0x02,
 0x02, 0x02, 0x02, 0x02, 0x05, 0x06, 0000, 0000, 0000, 0000, 0000, 0000,
 0x05, 0x06, 0000, 0000, 0x05, 0x06, 0000, 0x1b, 0x05, 0x06, 0000, 0000,
 0x13, 0x15, 0x16, 0x17, 0x05, 0x06, 0x05, 0x06, 0000, 0000, 0000, 0000,
 0x05, 0x06, 0x05, 0x06, 0x05, 0x06, 0000, 0000, 0x05, 0x06, 0x05, 0x06,
 0x05, 0x06, 0x05, 0x06, 0x05, 0x06, 0x05, 0x06, 0x05, 0x06, 0x18, 0x05,
 0x06, 0000, 0x05, 0x06, 0x05, 0x06, 0x05, 0x06, 0x06, 0x05, 0x06, 0x05,
 0x06, 0x05, 0x06, 0000, 0x06, 0x05, 0x06, 0x05, 0x06, 0x05, 0x06, 0x05,
 0x06, 0x05, 0x06, 0x05, 0x06, 0x1f, 0x05, 0x06, 0x06, 0x0d, 0x0d, 0x05,
 0x06, 0000, 0x0e, 0x0f, 0x06, 0x18, 0000, 0000, 0x05, 0x06, 0x18, 0x05,
 0x06, 0x19, 0x19, 0x05, 0x06, 0x05, 0x06, 0x1a, 0x07, 0x08, 0x05, 0x06,
 0x05, 0x06, 0x05, 0x06, 0x09, 0x05, 0x06, 0x05, 0x06, 0x05, 0x06, 0x0a,
 0x10, 0x05, 0x06, 0x0d, 0x11, 0x12, 0x13, 0x14, 0x1d, 0x1e, 0x1c, 0x1d,
 0x1e, 0x05, 0x06, 0x05, 0x22, 0000, 0x05, 0x06, 0x05, 0x06, 0x05, 0x06,
 0x25, 0000, 0000, 0x28, 0000, 0000, 0000, 0000, 0x29, 0x2a, 0000, 0000,
 0000, 0000, 0000, 0x2a, 0x2d, 0000, 0000, 0x2d, 0000, 0000, 0000, 0000,
 0x2d, 0000, 0x2e, 0x2e, 0000, 0000, 0000, 0000, 0x32, 0x32, 0x32, 0000,
 0x33, 0000, 0x34, 0x34, 0x3a, 0x3b, 0000, 0000, 0000, 0x3c, 0x3d, 0000,
 0x3e, 0x3f, 0x1f, 0000, 0x40, 0x41, 0000, 0000, 0x3f, 0x3f, 0x3f, 0x3f,
 0x3f, 0x3f, 0x3f, 0x3f, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42,
 0x43, 0x43, 0x43, 0x43, 0x43, 0x43, 0x43, 0000, 0x43, 0x43, 0x43, 0x43,
 0x43, 0x43, 0x43, 0x43, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0000,
 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x46, 0x46, 0000, 0000,
 0000, 0000, 0000, 0000, 0x46, 0x46, 0000, 0000, 0000, 0x54, 0000, 0000,
 0x46, 0x46, 0000, 0x4e, 0000, 0000, 0000, 0000, 0x46, 0x46, 0x46, 0x46,
 0x46, 0x46, 0000, 0000, 0x46, 0x46, 0x46, 0x46, 0x46, 0x46, 0x46, 0x46,
 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0000, 0000, 0x47, 0x47, 0x47, 0x47,
 0x47, 0x47, 0x47, 0x47, 0x47, 0x47, 0x4f, 0x4f, 0x50, 0000, 0x51, 0000,
 0x47, 0x47, 0x53, 0x53, 0000, 0000, 0000, 0000, 0x47, 0x47, 0x55, 0x55,
 0x56, 0000, 0000, 0000, 0x48, 0x48, 0x49, 0x49, 0x49, 0x49, 0x4a, 0x4a,
 0x4b, 0x4b, 0x4c, 0x4c, 0x4d, 0x4d, 0000, 0000, 0x52, 0x52, 0x52, 0x52,
 0x50, 0000, 0000, 0000, 0x57, 0x57, 0x58, 0x58, 0x50, 0000, 0000, 0000,
 0x5c, 0x5c, 0x5c, 0x5c, 0x5c, 0x5c, 0x5c, 0x5c, 0x5d, 0x5d, 0x5d, 0x5d,
 0x5d, 0x5d, 0x5d, 0x5d, 0x5e, 0x5e, 0x5e, 0x5e, 0x5e, 0x5e, 0x5e, 0x5e,
 0x5f, 0x5f, 0000, 0000, 0000, 0000, 0000, 0000, 0x5f, 0x5f, 0x5f, 0x5f,
 0x5f, 0x5f, 0x5f, 0x5f, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0000, 0000,
 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x60, 0x61, 0x61, 0x61, 0x61,
 0x61, 0x61, 0000, 0000, 0x61, 0x61, 0x61, 0x61, 0x61, 0x61, 0x61, 0x61,
};

#endif /* WANT_WCuplow_data */

#define WCuplow_diffs       98

#ifdef WANT_WCuplow_diff_data


static const short WCuplow_diff_data[196] = {
      0,      0,      0,     32,    -32,      0,    743,      0,
    121,      0,      0,      1,     -1,      0,      0,   -199,
   -232,      0,      0,   -121,   -300,      0,      0,    210,
      0,    206,      0,    205,      0,     79,      0,    202,
      0,    203,      0,    207,     97,      0,      0,    211,
      0,    209,      0,    213,    130,      0,      0,    214,
      0,    218,      0,    217,      0,    219,     56,      0,
      0,      2,     -1,      1,     -2,      0,    -79,      0,
      0,    -97,      0,    -56,      0,   -130,   -210,      0,
   -206,      0,   -205,      0,   -202,      0,   -203,      0,
   -207,      0,   -209,      0,   -211,      0,   -213,      0,
   -214,      0,   -218,      0,   -217,      0,   -219,      0,
     84,      0,      0,     38,      0,     37,      0,     64,
      0,     63,    -38,      0,    -37,      0,    -31,      0,
    -64,      0,    -63,      0,    -62,      0,    -57,      0,
    -47,      0,    -54,      0,    -86,      0,    -80,      0,
      0,    -60,    -96,      0,      0,     80,      0,     48,
    -48,      0,    -59,      0,      8,      0,      0,     -8,
     74,      0,     86,      0,    100,      0,    128,      0,
    112,      0,    126,      0,      9,      0,      0,    -74,
      0,     -9,  -7205,      0,      0,    -86,      0,   -100,
      7,      0,      0,   -112,      0,     -7,      0,   -128,
      0,   -126,      0,  -7517,      0,  -8383,      0,  -8262,
      0,     16,    -16,      0,      0,     26,    -26,      0,
      0,     40,    -40,      0,
};

#endif /* WANT_WCuplow_diff_data */

/* #include "lt_defines.h" */

/* TODO - fix */
#define MAGIC_SIZE 64

/* TODO - fix */
#ifdef __WCHAR_ENABLED
#define WCctype_TBL_LEN		(WCctype_II_LEN + WCctype_TI_LEN + WCctype_UT_LEN)
#define WCuplow_TBL_LEN		(WCuplow_II_LEN + WCuplow_TI_LEN + WCuplow_UT_LEN)
#define WCuplow_diff_TBL_LEN (2 * WCuplow_diffs)
/* #define WCcomb_TBL_LEN		(WCcomb_II_LEN + WCcomb_TI_LEN + WCcomb_UT_LEN) */
#endif

#undef __PASTE2
#define __PASTE2(A,B)		A ## B
#undef __PASTE3
#define __PASTE3(A,B,C)		A ## B ## C

#define COMMON_MMAP(X) \
	unsigned char	__PASTE3(lc_,X,_data)[__PASTE3(__lc_,X,_data_LEN)];

#define COMMON_MMIDX(X) \
	unsigned char	__PASTE3(lc_,X,_rows)[__PASTE3(__lc_,X,_rows_LEN)]; \
	uint16_t		__PASTE3(lc_,X,_item_offsets)[__PASTE3(__lc_,X,_item_offsets_LEN)]; \
	uint16_t		__PASTE3(lc_,X,_item_idx)[__PASTE3(__lc_,X,_item_idx_LEN)]; \


typedef struct {
	unsigned char magic[MAGIC_SIZE];

#ifdef __CTYPE_HAS_8_BIT_LOCALES
	const unsigned char tbl8ctype[Cctype_TBL_LEN];
    const unsigned char tbl8uplow[Cuplow_TBL_LEN];
#ifdef __WCHAR_ENABLED
	const uint16_t tbl8c2wc[Cc2wc_TBL_LEN]; /* char > 0x7f to wide char */
	const unsigned char tbl8wc2c[Cwc2c_TBL_LEN];
	/* translit  */
#endif /* __WCHAR_ENABLED */
#endif /* __CTYPE_HAS_8_BIT_LOCALES */
#ifdef __WCHAR_ENABLED
	const unsigned char tblwctype[WCctype_TBL_LEN];
	const unsigned char tblwuplow[WCuplow_TBL_LEN];
	const int16_t tblwuplow_diff[WCuplow_diff_TBL_LEN];
/* 	const unsigned char tblwcomb[WCcomb_TBL_LEN]; */
	/* width?? */
#endif /* __WCHAR_ENABLED */

	COMMON_MMAP(ctype);
	COMMON_MMAP(numeric);
	COMMON_MMAP(monetary);
	COMMON_MMAP(time);
	/* collate is different */
	COMMON_MMAP(messages);


#ifdef __CTYPE_HAS_8_BIT_LOCALES
	const codeset_8_bit_t codeset_8_bit[NUM_CODESETS];
#endif /* __CTYPE_HAS_8_BIT_LOCALES */

	COMMON_MMIDX(ctype);
	COMMON_MMIDX(numeric);
	COMMON_MMIDX(monetary);
	COMMON_MMIDX(time);
	/* collate is different */
	COMMON_MMIDX(messages);

	const uint16_t collate_data[__lc_collate_data_LEN];

	unsigned char lc_common_item_offsets_LEN[CATEGORIES];
    size_t lc_common_tbl_offsets[CATEGORIES * 4];
	/* offsets from start of locale_mmap_t */
	/* rows, item_offsets, item_idx, data */

#ifdef NUM_LOCALES
	unsigned char locales[NUM_LOCALES * WIDTH_LOCALES];
	unsigned char locale_names5[5*NUM_LOCALE_NAMES];
	unsigned char locale_at_modifiers[LOCALE_AT_MODIFIERS_LENGTH];
#endif /* NUM_LOCALES */

	unsigned char lc_names[lc_names_LEN];
#ifdef __CTYPE_HAS_8_BIT_LOCALES
	unsigned char codeset_list[sizeof(CODESET_LIST)]; /* TODO - fix */
#endif /* __CTYPE_HAS_8_BIT_LOCALES */


} __locale_mmap_t;

extern const __locale_mmap_t *__locale_mmap;
